## GUN SHOOT
# AS AT ANCHORED EYES of shooting player
# Used for ALL guns

##getting gun stats
execute store result score GunSound gbg.temp run data get entity @s SelectedItem.tag.GunSound
execute store result score GunMaxAmmo gbg.temp run data get entity @s SelectedItem.tag.GunMaxAmmo
execute store result score GunAmmo gbg.temp run data get entity @s SelectedItem.tag.GunAmmo
execute store result score GunDamage gbg.temp run data get entity @s SelectedItem.tag.GunDamage
execute store result score GunRange gbg.temp run data get entity @s SelectedItem.tag.GunRange
execute store result score GunFireRate gbg.temp run data get entity @s SelectedItem.tag.GunFireRate

#stopping funciton if out of ammo
execute if score GunAmmo gbg.temp matches ..0 unless score GunMaxAmmo gbg.temp matches 0 run return 0

## Playing Sound
execute if score GunSound gbg.temp matches ..0 run playsound minecraft:gbg_duck_quack player @a ~ ~ ~ 1 1
execute if score GunSound gbg.temp matches 1 run playsound minecraft:pistol_fire player @a ~ ~ ~ 1 1
execute if score GunSound gbg.temp matches 2 run playsound minecraft:assault_rifle_fire player @a ~ ~ ~ 1 1
execute if score GunSound gbg.temp matches 3 run playsound minecraft:sniper_rifle_fire player @a ~ ~ ~ 1 1
execute if score GunSound gbg.temp matches 4 run playsound minecraft:shotgun_fire player @a ~ ~ ~ 1 1
execute if score GunSound gbg.temp matches 4 run playsound minecraft:shotgun_cocking player @a ~ ~ ~ 1 1
execute if score GunSound gbg.temp matches 5 run playsound minecraft:bazooka_fire player @a ~ ~ ~ 1 1
execute if score GunSound gbg.temp matches 6 run playsound minecraft:entity.blaze.shoot player @a ~ ~ ~ 2 2
execute if score GunSound gbg.temp matches 7 run playsound minecraft:laser_pistol_fire player @a ~ ~ ~ 1 1
execute if score GunSound gbg.temp matches 8 run playsound minecraft:laser_rifle_fire player @a ~ ~ ~ 1 1
execute if score GunSound gbg.temp matches 9 run playsound minecraft:laser_cannon_fire player @a ~ ~ ~ 1 1
execute if score GunSound gbg.temp matches 10 run playsound minecraft:ray_gun_fire player @a ~ ~ ~ 1 1
execute if score GunSound gbg.temp matches 11 run playsound minecraft:minigun_fire player @a ~ ~ ~ 1 1


## Updating Description and Tags
# lowering gun current ammo
scoreboard players remove GunAmmo gbg.temp 1
# calculaitons for new "damage" (for the durability bar)
function gbg:calculate_durability
execute if score new_damage gbg.temp matches ..1 run scoreboard players set new_damage gbg.temp 1
# applying new damage and ammo tags
data modify storage gbg:generic tag set value {}
execute store result storage gbg:generic tag.Damage int 1 run scoreboard players get new_damage gbg.temp
execute store result storage gbg:generic tag.GunAmmo int 1 run scoreboard players get GunAmmo gbg.temp
execute unless score GunMaxAmmo gbg.temp matches ..0 run item modify entity @s weapon.mainhand gbg:general/change_damage
execute unless score GunMaxAmmo gbg.temp matches ..0 run item modify entity @s weapon.mainhand gbg:general/change_ammo
# calculating gun damage for explosive weapons
execute store result score GunProType gbg.temp run data get entity @s SelectedItem.tag.GunProType
execute if score GunProType gbg.temp matches 2 run function gbg:calculate_damage
execute if score GunProType gbg.temp matches 6 run function gbg:calculate_damage
execute if score GunProType gbg.temp matches 9 run function gbg:calculate_damage
# building lore
item modify entity @s weapon.mainhand gbg:general/remove
execute unless score GunMaxAmmo gbg.temp matches ..0 run item modify entity @s weapon.mainhand gbg:general/ammo
execute if score GunMaxAmmo gbg.temp matches ..0 run item modify entity @s weapon.mainhand gbg:general/infinite_ammo
item modify entity @s weapon.mainhand gbg:general/gun_damage
item modify entity @s weapon.mainhand gbg:general/gun_range
item modify entity @s weapon.mainhand gbg:general/fire_rate


## Setting Recoil
execute store result score RecoilType gbg.temp run data get entity @s SelectedItem.tag.RecoilType
execute if score RecoilType gbg.temp matches 1..3 run scoreboard players set @s gbg.recoil_duration 5
execute if score RecoilType gbg.temp matches 1 run scoreboard players set @s gbg.recoil_type 1
execute if score RecoilType gbg.temp matches 2 run scoreboard players set @s gbg.recoil_type 2
execute if score RecoilType gbg.temp matches 3 run scoreboard players set @s gbg.recoil_type 3


## Shooting Projectile
#all the cute preliminary stuff
execute store result score GunDamage gbg.temp run data get entity @s SelectedItem.tag.GunDamage
tag @s add gun_immune
scoreboard players operation @s gbg.cooldown = GunFireRate gbg.temp
execute store result storage gbg:macro input.source int 1 run scoreboard players get @s gbg.id
execute store result storage gbg:macro input.damage int 1 run scoreboard players get GunDamage gbg.temp
scoreboard players operation GunRange gbg.temp *= 10 number
#running the right raycast
execute if score GunProType gbg.temp matches 1 run function gbg:gun/projectile/bullet
execute if score GunProType gbg.temp matches 2 run function gbg:gun/projectile/rocket
execute if score GunProType gbg.temp matches 3 run function gbg:gun/projectile/fire
execute if score GunProType gbg.temp matches 4 run function gbg:gun/projectile/blaze_fire
execute if score GunProType gbg.temp matches 5 run function gbg:gun/projectile/laser
execute if score GunProType gbg.temp matches 6 run function gbg:gun/projectile/explosive_laser
execute if score GunProType gbg.temp matches 7 run function gbg:gun/projectile/green
execute if score GunProType gbg.temp matches 8 run function gbg:gun/projectile/blue
execute if score GunProType gbg.temp matches 9 run function gbg:gun/projectile/pink
execute if score GunProType gbg.temp matches 10 run function gbg:gun/projectile/red

## Shooting Additional Projectiles
#only does this if the fire rate = 1
execute if score GunFireRate gbg.temp matches 1 unless score @s gbg.burst_duration matches 1.. run scoreboard players set @s gbg.burst_duration 4

## End-of-Function Cleanup
# scoreboard players reset GunSound gbg.temp
# scoreboard players reset GunMaxAmmo gbg.temp
# scoreboard players reset GunAmmo gbg.temp
# scoreboard players reset GunDamage gbg.temp
# scoreboard players reset GunRange gbg.temp
# scoreboard players reset GunFireRate gbg.temp
# scoreboard players reset GunProType gbg.temp
# scoreboard players reset RecoilType gbg.temp

